/**
 *  This file is part of RegCEL.
 *
 *  Copyright (c) 2011 2012 Yunior Barceló Chávez barceloch@gmail.com
 *
 *  RegCEl is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  RegCEl is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with JIM.  If not, see <http://www.gnu.org/licenses/>.
 *
 **/
#include <QtGui>
#include "regcel_dialog.h"



RegCElDialog::RegCElDialog(QWidget *parent)
    : QDialog(parent)
{
    setupUi(this);

    QRegExp regExp("[1-9][0-9]{0,4}");
    lect_ant_LE->setValidator(new QRegExpValidator(regExp, this));
    lect_act_LE->setValidator(new QRegExpValidator(regExp, this));
    setWindowTitle(trUtf8("RegCEl Dialog 0.0.1"));

    //setWindowIcon(QIcon(":/images/icon.png"))
}


void RegCElDialog::on_lect_act_LE_textChanged()
{
  run_pButton->setEnabled(1);
}

void RegCElDialog::on_run_pButton_clicked()
{
   int kw_h = 0, kw_hDisplay = 0;
   double import = 0.00;
   int rangImport;

   kw_h =  lect_act_LE->text().toInt() - lect_ant_LE->text().toInt();
   kw_hDisplay = kw_h;
   lcd_Kwh->display(kw_hDisplay);

   if (kw_h > 0 && kw_h <= 100)
       rangImport = 1;

   if (kw_h > 100 && kw_h <= 150)
       rangImport = 2;

   if (kw_h > 150 && kw_h <= 200)
       rangImport = 3;

   if (kw_h > 200 && kw_h <= 250)
       rangImport = 4;

   if (kw_h > 250 && kw_h <= 300)
       rangImport = 5;

   if (kw_h > 300 && kw_h <= 350)
       rangImport = 6;

   if (kw_h > 350 && kw_h <= 500)
       rangImport = 7;

   if (kw_h > 500 && kw_h <= 1000)
       rangImport = 8;

   if (kw_h > 1000 && kw_h <= 5000)
       rangImport = 9;

   if (kw_h > 5000)
       rangImport = 10;

   switch (rangImport) {
       case 1:
               import = (0.09 * kw_h);
               kw_h = 0;
           break;

       case 2:
               kw_h -= 100;
               import = (0.09 * 100) + (0.30 * kw_h);
               kw_h = 0;
           break;

       case 3:
               kw_h -= 150;
               import = (0.09 * 100) + (0.30 * 50) + (0.40 * kw_h);
               kw_h = 0;
            break;

       case 4: 
               kw_h -= 200;
               import = (0.09 * 100) + (0.30 * 50) + (0.40 * 50) + (0.60 * kw_h);
               kw_h = 0;
           break;

       case 5:
               kw_h -= 250;
               import = (0.09 * 100) + (0.30 * 50) + (0.40 * 50) + (0.60 * 50) + ( 0.80 * kw_h);
               kw_h = 0;
           break;

       case 6:
                kw_h -= 300;
                import = (0.09 * 100) + (0.30 * 50) + (0.40 * 50) + (0.60 * 50) + ( 0.80 * 50) + (01.50 * kw_h);
                kw_h = 0;
            break;

       case 7:
                kw_h -= 350;
                import = (0.09 * 100) + (0.30 * 50) + (0.40 * 50) + (0.60 * 50) + ( 0.80 * 50) + (01.50 * 50) + (01.80 * kw_h);
                kw_h = 0;
            break;

       case 8:
                kw_h -= 500;
                import = (0.09 * 100) + (0.30 * 50) + (0.40 * 50) + (0.60 * 50) + ( 0.80 * 50) + (01.50 * 50) + (01.80 * 150) + (02.00 * kw_h);
                kw_h = 0;
            break;

       case 9:
                kw_h -= 1000;
                import = (0.09 * 100) + (0.30 * 50) + (0.40 * 50) + (0.60 * 50) + ( 0.80 * 50) + (01.50 * 50) + (01.80 * 150) + (02.00 * 500) + (03.00 * kw_h);
                kw_h = 0;
            break;

       case 10:
                kw_h -= 5000;
                import = (0.09 * 100) + (0.30 * 50) + (0.40 * 50) + (0.60 * 50) + ( 0.80 * 50) + (01.50 * 50) + (01.80 * 150) + (02.00 * 500) + (03.00 * 4000) + (05.00 * kw_h);
                kw_h = 0;
            break;
   }

   import_lb->setText(QString("%1 $").arg(QString::number(import, 'f', 2)));
   

}

void RegCElDialog::on_help_pButton_clicked()
{
    QMessageBox::about(this, trUtf8("Ayuda"),
            trUtf8("<p>Escriba cada lectura en la caja de texto correspondiente, "
               "al introducir datos válidos el Botón Calcular será habilitado, "
               "haga click en él y listo! ¿Fácil no? :). </p><p><b>Ejemplo:</b> Si­ ayer tomó la lectura 245 en su contador eléctrico y hoy tiene la lectura 354,"
               "en la caja de texto Lectura anterior: introduzca el primer valor: 245 y en la segunda caja de texto, "
               "pones 354 y haga click en Ejecutar.</p><p><b>Pasos: </b>"
               "1. Lecturas anterior: 245,"
               " 2. Lectura     actual:  354,"
               " 3. Click en Calcular</p>"));
	       
	    


}


void RegCElDialog::on_about_pButton_clicked()
{
    QMessageBox::about(this, trUtf8("RegCEl Dialog"),
        trUtf8("<h2>RegCEl 0.0.1 (BarSoft)</h2>"
        "<h3>Registro del Consumo Eléctrico</h3>"
        "<p>(C) 2012 Yunior Barceló Chávez <a href= \"mailto:barceloch@gmail.com\" >barceloch@gmail.com</a></p>"
        "<p><a href= \http://gutl.jovenclub.cu\" >http://gutl.jovenclub.cu/</a></p>"
        "<p><a href= \http://humanos.uci.cu\" >http://humanos.uci.cu/</a></p>"
        "<p>Licensed under <a href= \"http://www.gnu.org/licenses/gpl.html\" >GNU General Public License version 3</a></p>"));
}
